# coding: utf-8

"""
    AssistedInstall

    Assisted installation  # noqa: E501

    OpenAPI spec version: 1.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class UpdateManifestParams(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'folder': 'str',
        'file_name': 'str',
        'updated_folder': 'str',
        'updated_file_name': 'str',
        'updated_content': 'str'
    }

    attribute_map = {
        'folder': 'folder',
        'file_name': 'file_name',
        'updated_folder': 'updated_folder',
        'updated_file_name': 'updated_file_name',
        'updated_content': 'updated_content'
    }

    def __init__(self, folder='manifests', file_name=None, updated_folder='manifests', updated_file_name=None, updated_content=None):  # noqa: E501
        """UpdateManifestParams - a model defined in Swagger"""  # noqa: E501

        self._folder = None
        self._file_name = None
        self._updated_folder = None
        self._updated_file_name = None
        self._updated_content = None
        self.discriminator = None

        self.folder = folder
        self.file_name = file_name
        if updated_folder is not None:
            self.updated_folder = updated_folder
        if updated_file_name is not None:
            self.updated_file_name = updated_file_name
        if updated_content is not None:
            self.updated_content = updated_content

    @property
    def folder(self):
        """Gets the folder of this UpdateManifestParams.  # noqa: E501

        The folder for the manifest to modify.  # noqa: E501

        :return: The folder of this UpdateManifestParams.  # noqa: E501
        :rtype: str
        """
        return self._folder

    @folder.setter
    def folder(self, folder):
        """Sets the folder of this UpdateManifestParams.

        The folder for the manifest to modify.  # noqa: E501

        :param folder: The folder of this UpdateManifestParams.  # noqa: E501
        :type: str
        """
        if folder is None:
            raise ValueError("Invalid value for `folder`, must not be `None`")  # noqa: E501
        allowed_values = ["manifests", "openshift"]  # noqa: E501
        if folder not in allowed_values:
            raise ValueError(
                "Invalid value for `folder` ({0}), must be one of {1}"  # noqa: E501
                .format(folder, allowed_values)
            )

        self._folder = folder

    @property
    def file_name(self):
        """Gets the file_name of this UpdateManifestParams.  # noqa: E501

        The file name for the manifest to modify.  # noqa: E501

        :return: The file_name of this UpdateManifestParams.  # noqa: E501
        :rtype: str
        """
        return self._file_name

    @file_name.setter
    def file_name(self, file_name):
        """Sets the file_name of this UpdateManifestParams.

        The file name for the manifest to modify.  # noqa: E501

        :param file_name: The file_name of this UpdateManifestParams.  # noqa: E501
        :type: str
        """
        if file_name is None:
            raise ValueError("Invalid value for `file_name`, must not be `None`")  # noqa: E501

        self._file_name = file_name

    @property
    def updated_folder(self):
        """Gets the updated_folder of this UpdateManifestParams.  # noqa: E501

        The new folder for the manifest. Manifests can be placed in 'manifests' or 'openshift' directories.  # noqa: E501

        :return: The updated_folder of this UpdateManifestParams.  # noqa: E501
        :rtype: str
        """
        return self._updated_folder

    @updated_folder.setter
    def updated_folder(self, updated_folder):
        """Sets the updated_folder of this UpdateManifestParams.

        The new folder for the manifest. Manifests can be placed in 'manifests' or 'openshift' directories.  # noqa: E501

        :param updated_folder: The updated_folder of this UpdateManifestParams.  # noqa: E501
        :type: str
        """
        allowed_values = ["manifests", "openshift"]  # noqa: E501
        if updated_folder not in allowed_values:
            raise ValueError(
                "Invalid value for `updated_folder` ({0}), must be one of {1}"  # noqa: E501
                .format(updated_folder, allowed_values)
            )

        self._updated_folder = updated_folder

    @property
    def updated_file_name(self):
        """Gets the updated_file_name of this UpdateManifestParams.  # noqa: E501

        The new file name for the manifest.  # noqa: E501

        :return: The updated_file_name of this UpdateManifestParams.  # noqa: E501
        :rtype: str
        """
        return self._updated_file_name

    @updated_file_name.setter
    def updated_file_name(self, updated_file_name):
        """Sets the updated_file_name of this UpdateManifestParams.

        The new file name for the manifest.  # noqa: E501

        :param updated_file_name: The updated_file_name of this UpdateManifestParams.  # noqa: E501
        :type: str
        """

        self._updated_file_name = updated_file_name

    @property
    def updated_content(self):
        """Gets the updated_content of this UpdateManifestParams.  # noqa: E501

        The new base64 encoded manifest content.  # noqa: E501

        :return: The updated_content of this UpdateManifestParams.  # noqa: E501
        :rtype: str
        """
        return self._updated_content

    @updated_content.setter
    def updated_content(self, updated_content):
        """Sets the updated_content of this UpdateManifestParams.

        The new base64 encoded manifest content.  # noqa: E501

        :param updated_content: The updated_content of this UpdateManifestParams.  # noqa: E501
        :type: str
        """

        self._updated_content = updated_content

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(UpdateManifestParams, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateManifestParams):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
